autofs-5.1.8 - add null check in master_kill()

From: Ian Kent <raven@themaw.net>

Try harder to avoid possibility of invalid accesses in master_kill().

Signed-off-by: Ian Kent <raven@themaw.net>
---
 CHANGELOG       |    1 +
 daemon/master.c |    5 +++++
 2 files changed, 6 insertions(+)

diff --git a/CHANGELOG b/CHANGELOG
index 8fc6c231..23efc053 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -101,6 +101,7 @@
 - always recreate credential cache.
 - fix ldap_parse_page_control() check.
 - fix typo in create_cmd_pipe_fifo().
+- add null check in master_kill().
 
 19/10/2021 autofs-5.1.8
 - add xdr_exports().
diff --git a/daemon/master.c b/daemon/master.c
index d23954ee..f2c11e90 100644
--- a/daemon/master.c
+++ b/daemon/master.c
@@ -1951,6 +1951,9 @@ unsigned int master_get_logopt(void)
 
 int master_kill(struct master *master)
 {
+	if (!master)
+		return 1;
+
 	if (!master_list_empty(master))
 		return 0;
 
@@ -1960,5 +1963,7 @@ int master_kill(struct master *master)
 	cache_release_null_cache(master);
 	free(master);
 
+	master_list = NULL;
+
 	return 1;
 }
